<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\goods_time;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\goods_time\GoodsTime;
use app\common\lists\ListsSearchInterface;


/**
 * GoodsTime列表
 * Class GoodsTimeLists
 * @package app\adminapi\listsgoods_time
 */
class GoodsTimeLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public function setSearch(): array
    {
        return [
            '=' => ['service_time'],
        ];
    }
    
    public function queryWhereRaw(){
        $where = '1=1';

        if(isset($this->params['goods_category_ids']) && !empty($this->params['goods_category_ids'])){
            $sqls = [];
            $goods_category_ids =[];
            foreach ($this->params['goods_category_ids'] as $val){
                ($val = json_decode($val,true))?($goods_category_ids[] = end($val)):($goods_category_ids[] = $val);
            }
            foreach ($goods_category_ids as $item) {
                $sqls[] = "FIND_IN_SET({$item}, goods_category_ids) > 0";
            }
            $where = implode(' OR ', $sqls);
        }
        return $where;
    }

    public function queryWhere(){
        $where = [];
        if(isset($this->params['title']) && !empty($this->params['title'])){
            $where[] = ['title', 'like','%' .$this->params['title'] . '%'];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public function lists(): array
    {
        $list = GoodsTime::where($this->searchWhere)
            ->where($this->queryWhere())
            ->whereRaw($this->queryWhereRaw())
            ->field(['id', 'title','service_time', 'goods_category_ids'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
        foreach($list as &$item) {
            $item['goods_category_ids'] = explode(',', $item['goods_category_ids']);
        }
        return $list;
    }

    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2025/02/23 11:02
     */
    public function count(): int
    {
        return GoodsTime::where($this->searchWhere)->count();
    }

}